/*
  Example of compacting clauses using unit propagation.
*/


#include"dp.h"

main() {
  setofclauses cl;
  setofclauses rcl;
  int **name;
  int u;

				/* read a set of clauses */
  cl=newsetofclauses();
  readclauses(stdin, &cl);


				/* compact without renaming */
 
  u=compact(cl, &rcl, 0, NULL);

  if( u==1 ) {
    printf("Formula has exactly one model.\n");
    return 0;
  }

  if( u==-1 ) {
    printf("Inconsistent.\n");
    return 0;
  }

  printf("Compacted set of clauses (without renaming):\n");
  printclauses(rcl);

  freeclauses(rcl);


				/* compact with renaming */

  u=compact(cl, &rcl, 1, name);

  printf("Compacted set of clauses (with renaming):\n");
  printclauses(rcl);

  freeclauses(cl);
  freeclauses(rcl);

  return 0;
}
