#include"dp.h"

main () {
  setofclauses cl;
  clauseindex ix;
  state stt;
  stack stk;
  int i,k;

  cl=newsetofclauses();
  initsetofclauses(&cl);

  addliteral(1,&cl);
  addliteral(2,&cl);
  endclause(&cl);

  addliteral(-1,&cl);
  addliteral(-2,&cl);
  endclause(&cl);

  addliteral(3,&cl);
  endclause(&cl);

  for(i=1; i<=3; i++)
    setweight(i, 1, &cl);


  k=firstminweight( cl, &ix, &stt, &stk, DEFAULTDP );


  if( k<0 )
    printf("Inconsistent\n");
  else {
    printf("Consistent, minimal weight=%d\n",k);
    printf("Minimal models:\n");

    for(i=1; i<=3; i++)
      printf("%d=%d ",i,valueofvar(i,stt));
    printf("\n");

    while( nextminweight( k, cl, ix, stt, stk, DEFAULTDP ) != -1 ) {
      for(i=1; i<=3; i++)
        printf("%d=%d ",i,valueofvar(i,stt));
      printf("\n");
    }
  }

  return 0;
}
