#include"dp.h"

main() {
  setofclauses cl;
  clauseindex ix;
  state stt;
  stack stk;
  int i;

  /* .... */

  cl=newsetofclauses();
  initsetofclauses(&cl);

  addliteral( -1, &cl );
  addliteral( 2, &cl );
  endclause( &cl );

  addliteral( 2, &cl );
  addliteral( -3, &cl );
  addliteral( 4, &cl );
  addliteral( 7, &cl );
  endclause( &cl );

  if( firstmodel( cl, &ix, &stt, &stk, DEFAULTDP ) == -1 )
    printf("Inconsistent\n");
  else {
    printf("Consistent\n");
    printf("Model:\n");

    for(i=1; i<=7; i++)
      printf("val(%d)=%2d  ",i,valueofvar( i, stt ) );
    printf("\n");

    while( nextmodel( cl, ix, stt, stk, DEFAULTDP ) != -1 ) {
      for(i=1; i<=7; i++)
        printf("val(%d)=%2d  ",i,valueofvar( i, stt ) );
      printf("\n");
    }
  }

  printf("Meaning of value:\n\t-1\tvariable is false.\n");
  printf("\t1\tvariable is true\n");
  printf("\t0\tvariable is unassigned (can take any value)\n");

  freeclauses(cl);
}

