/*
  Definizioni di tutte le liste usate. Questo file
contiene: la definizione di NULL e NEW, le definizioni
di tutti i puntatori e di tutti i record.
  Contiene anche tutti gli header delle funzioni cons
di tutte queste liste. Le definizioni di queste
funzioni si trovano in list.c
*/

#include<stdio.h>


			/* null */

#ifdef NULL
#else
  #define NULL 0
#endif


			/* list of integers */

typedef struct reclistofint *listofint;

struct reclistofint {
  int elem;
  listofint next;
};

				/* nuova lista, in cui i e' il primo nuovo elemento */
listofint conslistofint( listofint l, int i );

				/* reverse of a list (the old list is not deallocated */
listofint reverselistofint( listofint l );

				/* deallocate all the elements of a list */
int freelistofint( listofint l );

				/* sort al list */

int sortlistofint( listofint index, listofint values, int comparison( int, int ) );

				/* print a list */
int printlistofint( FILE *stream, listofint l );


