%{
#include<stdio.h>
#include"global.h"
#include"formulae.h"

void maxu( int i, int *j, int l ) {

  if( i>l ) {
    printf("Limit exeeded.\n");
    exit(1);
  }

  if (i>(*j))
    (*j)=i;
}

%}

%union {
  int val;
  formula form;
};

%token <val> NUM

%type <form> formula 

%left '|'
%left '&'
%left '~'

%%
file: formula				{ f=$1; }
;

formula: NUM				{ $$=newleaf($1); maxu($1,&numvar,MAXNUMVAR); }
	| formula '|' formula		{ $$=andor($1,$3,OR); }
	| formula '&' formula		{ $$=andor($1,$3,AND); }
	| '~' formula			{ $$=andor(NULL,$2,NOT); }
	| '(' formula ')'		{ $$=$2; }
;

%%
int yyerror( char *s ) {
  printf("Error: %s",s);
  exit(1);
}

	

