/*
  Determine the average on each col
*/

#include<stdio.h>

main( int argc, char *argv[] ) {
  FILE *input;
  FILE *output;
  char outname[100];

  int numpoints;
  int valorex;
  int valorey[10000];
  int numval;
  int x,y;
  int i;
  int m;


					/* argument: file name */

  if( argc<3 ) {
    printf("Usage:\n");
    printf("\ttable2average numpoints filename\n");
    exit(1);
  }

  numpoints=atoi(argv[1]);

					/* open input file */

  input=fopen(argv[2],"r");
  if( input==NULL ) {
    perror("Opening input file");
    exit(1);
  }


					/* open output file */

  strcpy(outname,argv[2]);
  strcat(outname,"-avg");
  output=fopen(outname,"w");
  if( output==NULL ) {
    perror("Opening output file");
    exit(1);
  }


					/* read first line */

  fscanf(input,"%d %d",&x,&y);


					/* main loop */

  while( !feof(input) ) {

    valorex=x;
    valorey[0]=y;
    numval=1;


					/* read a vertical line (set of points with
					   the same x coordinates */

    while( x<=valorex+numpoints-1 ) {
      fscanf(input,"%d %d",&x,&y);

      if( feof(input) )
        break;

      valorey[numval]=y;
      numval++;
    }
  
    if( numval==0 ) 
      break;

					/* determine average */

    m=0;
    for(i=0; i<numval; i++)
      m+=valorey[i];
    m=m/numval;


					/* print average on file */

    fprintf(output,"%d %d\n",valorex+numpoints/2,m);

  }


					/* close files */

  fclose(input);
  fclose(output);

  return 0;
}
