#define MAXCLASSES 10
#define MAXELEM MAXCLAUSES

#define ENDOFCLASS -1

#ifdef NULL
#else
#define NULL 0
#endif

typedef struct {
  int class;
  int prev;
  int next;
} partitionelem;

typedef struct {
  int maxclass;
  int initclass[MAXCLASSES];
  int maxelem;
  partitionelem elem[MAXELEM];
} partition;



				/* allocate space for a partition */

partition *newpartition(); 

				/* all the elements are initially in class 0 */

int initpartition( int numelem, int numpartitions, partition *prt );

				/* remove element from its class (not to be used outside the module) */
/*
int rmelem( int elem, partition *prt );
*/
				/* add element to a class (not to be used directly) */
/*
int addelem( int elem, int class, partition *prt );
*/
				/* move element to class c */

int moveelem( int elem, int class, partition *prt );

				/* gives the class of an element */

int whichclass( int elem, partition *prt );

				/* is class empty? */

int isclassempty( int class, partition *prt );

				/* first element of a class */

int firstofclass( int class, partition *prt );

				/* next element of a class (given the previous one) */

int nextofclass( int elem, partition *prt );

				/* copy a partition */

int copypartition( partition *prt1, partition *prt2 );

				/* print all the elements of a class */

int printclass( int class, partition *prt );


