/*
  Type and procedures for queues
Queues are represented as an array of integers,
and two integers representinf the first element
introduced (that is, the first to be removed, in),
and the last introduced (which is the position in
which new elements are put.
*/

#define MAXQUEUE 10000

#ifdef NULL
#else
  #define NULL 0
#endif

typedef struct {
  int in;
  int out;
  int elem[MAXQUEUE+1];
} queue;

			/* check whether a queue is empty */
int isempty( queue *q );

			/* insert element in queue */
void inqueue( queue *q, int x );

			/* extract an element from a queue */
int outqueue( queue *q );

			/* next element of a queue (not removed from queue */
int topqueue( queue *q );

			/* allocate a queue */
queue *emptyqueue();

			/* remove all elements from a queue */
int rmallqueue( queue *q );

			/* print all elements of a queue */
int printqueue( queue *q );
