/*
  Convert a table to a .ps file.
*/

#include<stdio.h>

int drawcross( FILE *output, int x, int y ) {
  fprintf(output,"%d %d moveto\n",x-5,y);
  fprintf(output,"%d %d lineto\n",x+5,y);
  fprintf(output,"%d %d moveto\n",x,y-5);
  fprintf(output,"%d %d lineto\n",x,y+5);
  fprintf(output,"%d %d moveto\n",x,y);

  return 0;
}


main( int argc, char *argv[] ) {
  FILE *input;
  FILE *output;
  char outname[100];

  int x,y;
  int oldx,oldy;


					/* argument: file name *?

  if( argc<2 ) {
    printf("Manca il nome del file.\n");
    exit(1);
  }


					/* open input file */

  input=fopen(argv[1],"r");
  if( input==NULL ) {
    perror("Opening input file");
    exit(1);
  }


					/* open output file */

  strcpy(outname,argv[1]);
  strcat(outname,".ps");
  output=fopen(outname,"w");
  if( output==NULL ) {
    perror("Opening output file");
    exit(1);
  }

  fprintf(output,"%!\n");

					/* read first line */

  fscanf(input,"%d %d",&x,&y);
  oldx=x;
  oldy=y;
  drawcross(output,x,y);


					/* main loop */

  while( !feof(input) ) {
    fscanf(input,"%d %d",&x,&y);
    fprintf(output,"%d %d lineto\n",x,y);
    drawcross(output,x,y);
  }


					/* close files */

  fprintf(output,"stroke\n");

  fclose(input);
  fclose(output);

  return 0;
}

